/*
NAME: ThunderBrowse History
AUTH: GameSpotting! Networks
DESC: Handles ThunderBrowse's history functions
*/
var TBHistory = {
  historyDupeRemover : function (a)
  {
   //this code is from http://tinyurl.com/bjzkxu 
   var r = new Array();
   o:for(var i = 0, n = a.length; i < n; i++)
   {
      for(var x = 0, y = r.length; x < y; x++)
      {
         if(r[x]==a[i]) continue o;
      }
      r[r.length] = a[i];
   }
   return r;  
  },
  urlEncodin : function (url)
  {
    //encodes urls if they have commas in them (fixes comma bug)
    if(url.split(",")[1] != null)
    {
     var encoded = encodeURIComponent(url);
     var newurl = "ENC:"+encoded;
     return newurl;
    }
    else
     return url;
  },
  urlDecodin : function (url)
  {
    //decodes encoded urls (fixes comma bug)
    if(url.split("ENC:")[1] != null)
    {
     var removePrefix = url.split("ENC:")[1];
     return decodeURIComponent(removePrefix);
    }
    else
     return url;
  },
  getBackHistory : function(browser)
  {
    if(gTBBack)
    {
      //captures back history
    	var usershp = TBrowseDev.getUserHomepage();
    	var myoldspec = browser.currentURI.spec;
    	if(myoldspec != "about:blank" && (browser.currentURI.scheme == "mailbox" 
    	|| (browser.getAttribute("history-back") == "" || myoldspec == usershp)))
    	{
    		var newArray = new Array(myoldspec);
    		browser.setAttribute("history-back",newArray);
    		gTBBack.setAttribute("disabled",false);
    
    	}
    	else if(browser.getAttribute("history-back") != "")
    	{
    		if(myoldspec != "about:blank" && myoldspec.split("mailto:")[0] != "" 
    		&& myoldspec.split("javascript:")[0] != "")
    		{
    			var getoldhistory = new Array(browser.getAttribute("history-back"));
    			var encHistUrl = TBHistory.urlEncodin(myoldspec);
    			getoldhistory.push(encHistUrl);
    			browser.setAttribute("history-back",getoldhistory);
    			gTBBack.setAttribute("disabled",false);
    	  }
      }
     }
	   return 0;  
  },
  goBack : function(event,browser)
  {
   if(gTBBack)
   {
      if(gTBBack.disabled == true)
    	{
    		return 0;
    	}
    	else if(event != null && (event.button != 1 || event == 8))
    	{
    	  //event 8 is an unnatural number. It allows going back via the API
    		if(browser && browser != null)
    			tbrowser = browser;
    		var backattribute=tbrowser.getAttribute("history-back");
    		var backurl = backattribute.split(",");
    		var superback= backurl.pop();
    		//if we call superback again, we'll get another url. So inorder to keep the first
    		//url, we save it in a pref
    		thunderbrowseprefs.setCharPref("gourlback",superback);			
    		tbrowser.setAttribute("history-back",backurl);
    		TBHistory.updateHistoryMenu("last",browser);
    		var urlDecoded = TBHistory.urlDecodin(thunderbrowseprefs.getCharPref("gourlback"));
    		ThunderBrowse.loadURL(urlDecoded,tbrowser, null, null, 4);
     		if(backurl.length == 0)
    		{ 		
    			tbrowser.setAttribute("history-back","");
    			gTBBack.setAttribute("disabled",true);
    		}		
    	}
    }  
  },
  getFwdHistory : function(backurl,browser)
  {
   if(gTBFwd)
   {
      //captures forward history
      if(browser.getAttribute("history-forward") == "")
    	{
    		var newFwdArray = new Array(backurl);
    		browser.setAttribute("history-forward",newFwdArray);
    		gTBFwd.setAttribute("disabled",false);
    
    	}
    	else if(backurl.match("about:blank") == null && browser.getAttribute("history-forward") != "")
    	{
    		var getnewfuture = new Array(browser.getAttribute("history-forward"));
         	var encHistUrl = TBHistory.urlEncodin(backurl);
    		getnewfuture.push(encHistUrl);
    		browser.setAttribute("history-forward",getnewfuture);
    		gTBFwd.setAttribute("disabled",false);
    	}
	 }
	 return 0;  
  },
  goForward : function(browser)
  {
    if(gTBFwd)
    {
    	if(gTBFwd.disabled == true)
    	{
    		return 0; 
    	}
    	else  
    	{      
    		if(browser && browser != null)
    			tbrowser = browser;
    		var forwardurl = tbrowser.getAttribute("history-forward").split(",");
    		var theurltogofwdto=forwardurl.pop();						
    		thunderbrowseprefs.setCharPref("gourlfwd",theurltogofwdto);			
    		tbrowser.setAttribute("history-forward",forwardurl);
    		var urlDecoded = TBHistory.urlDecodin(theurltogofwdto);
    		ThunderBrowse.loadURL(urlDecoded,tbrowser, null, null, 5);
      		if(forwardurl.length == 0)
    		{
    			tbrowser.setAttribute("history-forward","");
    			gTBFwd.setAttribute("disabled",true);
    		}	
    	}
    }  
  },
  captureRecentUrls : function(browser)
  {
    //this function is like our history function, partially because this has to do with such feature
  	var myoldpast = browser.currentURI.spec;
  	var usershp = TBrowseDev.getUserHomepage();
  	if(browser.currentURI.scheme == "mailbox" || (thunderbrowseprefs.getCharPref("dropdown") == "" 
  	/* && myoldpast == usershp */))
  	{
  		var wasmailbox = browser.currentURI.spec;
  		thunderbrowseprefs.setCharPref("dropdown",wasmailbox);
  	}
  	else if(thunderbrowseprefs.getCharPref("dropdown") != "")
  	{
  		if(myoldpast.split("mailto:")[0] != "" && myoldpast.split("javascript:")[0] != "")
  		{
  			var getoldhistory = thunderbrowseprefs.getCharPref("dropdown");
  			if(gTBURLBox)
  			{
  			  var urlbar = gTBURLBox.value;
  			  var encHistUrl = TBHistory.urlEncodin(urlbar);
  			  var myoldpast2 = getoldhistory+","+encHistUrl;
  			  thunderbrowseprefs.setCharPref("dropdown",myoldpast2);
  			}
  		}
  	}
  	return 0;  
  },
  reloadBackMenu : function()
  {
   if(gTBHistDD)
   {
		for(var e = 0; e < gTBHistDD.childNodes.length; ++e)
		{
			var removeme = gTBHistDD.childNodes[e];
			gTBHistDD.removeChild(removeme);
		}
		if(gTBHistDD.childNodes.length == 0)
			return 0;
		else
			TBHistory.reloadBackMenu();
   }  
  },
  updateHistoryMenu : function(event,browser)
  {
   var DOMurlDecode = null;
   //last means that it came from the back button instead of a menuitem
   if(event != "last")
   {
     var eventNumber = event.target.getAttribute("number");
     if(browser && browser != null)
       tbrowser = browser;
     else
	     checkBrowser();
     var backattribute=tbrowser.getAttribute("history-back");
     if(backattribute.length != 0)
     {
	    var historyArray = backattribute.split(",");
	    var updateHistory = historyArray.slice(0,eventNumber);
         /*
         The following code adds the urls back to the forward button.
         There is a problem with the currently viewed page getting inserted to the 2nd place
         in the history. This is a bug where a fix is not planned any time soon.
         */
	    var endofRoute = historyArray.length;
    	if(endofRoute != 0)
    	{
    	  var updateForward = historyArray.slice(eventNumber,endofRoute);
    	  var fwdhist = TBHistory.historyDupeRemover(updateForward);
    	  var revfwdhist = fwdhist.reverse();
    	  if(fwdhist.length > 3)
    	  {
    	    var onefwdurl = revfwdhist[0];
    	    revfwdhist.push(onefwdurl);
    	    var splitstart = Math.round((endofRoute - eventNumber)/2);
    	    var sliceagain = historyArray.slice(splitstart + 1,fwdhist.length+1);
    	    var finfwdhist = sliceagain.reverse();
    	  }
    	  else
    	  {
    	    revfwdhist.pop();
    	    var finfwdhist = revfwdhist;
    	  } 
    	  gTBFwd.setAttribute("disabled",false);
    	  tbrowser.setAttribute("history-forward",finfwdhist);
     	}
    	var domElement = event.originalTarget.getAttribute("label");
    	/* gTBHistDD.childNodes[eventNumber].label */
    	DOMurlDecode = TBHistory.urlDecodin(domElement);
    	thunderbrowseprefs.setCharPref("gourlback",DOMurlDecode);			
    	tbrowser.setAttribute("history-back", updateHistory);
    	if(historyArray.length == 0 || historyArray == "")
    	{ 		
    	  tbrowser.setAttribute("history-back","");
    	  gTBBack.setAttribute("disabled",true);
    	}
         }
         gTBHistDD.hidePopup(); 
       }
       TBHistory.reloadBackMenu();
       TBHistory.generateDropdown("back",true);
       if(event != "last")
       {
        if(DOMurlDecode == null)
         DOMurlDecode = TBHistory.urlDecodin(event.target.label);
		  ThunderBrowse.loadURL(DOMurlDecode, tbrowser, null, null, 4);
       }
  },
  generateDropdown : function (whatpopup, hide)
  {
    checkBrowser();
    if(whatpopup == "back" && gTBBack.disabled != true)
    {
     TBHistory.reloadBackMenu();
     var movehere = gTBBack;
     if(hide != null)
      {/*something*/}
     else
      gTBHistDD.showPopup(movehere,-1, -1, "popup", 'bottomleft', 'topleft');
     var getoldhistory = tbrowser.getAttribute("history-back");
     var thedropdown = gTBHistDD;  	
    }
    if(whatpopup != "back" || whatpopup == null)
    {
     var movehere = gTBURLBox;
     TBHistory.reloadBackMenu();
     gTBDropDown.showPopup(movehere,-1, -1, "popup", 'bottomleft', 'topleft');
     var getoldhistory = thunderbrowseprefs.getCharPref("dropdown");
     var thedropdown = gTBDropDown;
    }
    //if dropdown exists, it's possible the user removed it via the dom inspector
    if(thedropdown)
    {
    	//split the pref
    	var historyArray = getoldhistory.split(",");
    	for(var i = 0; i < historyArray.length; i++)
    	{
    	   //get the urls in the pref
    	   var geturl = historyArray[i];
    	   if(geturl)
    	   {
    	    //if the url doesn't exist in the drop down already then add it
    	    if(!$(geturl))
    	    {
    	      var createdropdown = document.createElement("menuitem");
    	      var urlDecLabel = TBHistory.urlDecodin(geturl);
    	      createdropdown.setAttribute("label",urlDecLabel);
    	      if(whatpopup == "back")
    	      {
    		 createdropdown.setAttribute("number",i);
             createdropdown.setAttribute("oncommand","TBHistory.updateHistoryMenu(event);");
    	      }
    	      else
    		   createdropdown.setAttribute("oncommand","ThunderBrowse.loadURL(event, null, null, null, 2);");
    	      createdropdown.setAttribute("id",geturl);
    	      thedropdown.appendChild(createdropdown);
           }
    	   }
    	}
    } 
}
};
