/*
NAME: ThunderBrowse Pointers
AUTH: GameSpotting! Networks
DESC: Defines ThunderBrowse's Pointer handling. Allows us to support both TB2 and TB3
*/

var gTBNavBar;
var gTBURLBox;
var gTBBack;
var gTBFwd;
var gTBGo;
var gTBFavDeck;
var gTBFavico;
var gTBFavErr;
var gTBDropDown;
var gTBHistDD;

var TBrowseNavBar = {
	//Checks to see if this is a ThunderBrowse tab, if not, it will return false.
	tabTypes: function()
	{
	 var getPrefs = Components.classes["@mozilla.org/preferences-service;1"]
					.getService(Components.interfaces.nsIPrefService).getBranch("extensions.tbrowse.");
	 var tabtype = getPrefs.getIntPref("tabtype");
	 /*
	 Valid tab types:
	 1 = TB2 tabs
	 2 = TB3 tabs with hook
	 3 = TB3 tabs without hook
	 */
     var wintype = document.documentElement.getAttribute("windowtype");
	 if((tabtype == 1 || tabtype == 2) && wintype != "mail:messageWindow" && wintype != "tbrowse:win")
	 {
	  if(TBrowseGlobal.getTabHandler().currentTabInfo.mode.type == "thunderbrowse")
		return true;
	 }
	 
	 return false;
	},
	tabSwitch: function()
	{
	 try
	 {
		var kind = TBrowseNavBar.tabTypes();
		//If this is a ThunderBrowse tab
		if(kind == true)
		{
			var urlbarEl = TBrowseGlobal.getTabHandler().currentTabInfo.urlbar;
			gTBNavBar = urlbarEl;
			gTBURLBox = urlbarEl.childNodes[5];
			gTBBack = urlbarEl.childNodes[0];
			gTBFwd = urlbarEl.childNodes[2];
			gTBGo = urlbarEl.childNodes[7];
			gTBFavDeck = urlbarEl.childNodes[5].childNodes[0];
			gTBFavico = urlbarEl.childNodes[5].childNodes[0].childNodes[0];
			gTBFavErr = urlbarEl.childNodes[5].childNodes[0].childNodes[1];
			gTBDropDown = urlbarEl.childNodes[6];
			gTBHistDD = urlbarEl.childNodes[1]; 
		}
		//if it's not.
		else if(kind == false)
		{
			gTBNavBar = document.getElementById("urlbox");
			gTBURLBox = document.getElementById("urlfield");
			gTBBack = document.getElementById("urlbar-bck");
			gTBFwd = document.getElementById("urlbar-fwd");
			gTBGo = document.getElementById("urlbar-go");
			gTBFavDeck = document.getElementById("favIconDeck");
			gTBFavico = document.getElementById("favicon");
			gTBFavErr = document.getElementById("faviconerror");
			gTBDropDown = document.getElementById("tbrowsedropdown");
			gTBHistDD = document.getElementById("tbrowsebackdown");
		}
	 }
	 catch(e)
	 {
	  gTBNavBar = document.getElementById("urlbox");
	  gTBURLBox = document.getElementById("urlfield");
	  gTBBack = document.getElementById("urlbar-bck");
	  gTBFwd = document.getElementById("urlbar-fwd");
	  gTBGo = document.getElementById("urlbar-go");
	  gTBFavDeck = document.getElementById("favIconDeck");
	  gTBFavico = document.getElementById("favicon");
	  gTBFavErr = document.getElementById("faviconerror");
	  gTBDropDown = document.getElementById("tbrowsedropdown");
	  gTBHistDD = document.getElementById("tbrowsebackdown");
	 }
		
	},
	addWatcher: function()
	{
     var wintype = document.documentElement.getAttribute("windowtype");
	 try
	 {
	  if(TBrowseGlobal.getTabHandler() && (wintype  == "mail:3pane" || wintype  == "collab:main"))
		TBrowseGlobal.getTabHandler().registerTabMonitor(ThunderBrowseMon);
	 }
	 catch(e)
	 {
		if(TBrowseGlobal.app == null)
		{
		  TBrowseGlobal.checkApplication();
		  TBrowseGlobal.updateTabsCheck();
		}
		
		if(TBrowseGlobal.appTabsAllowed == false)
		TBrowseGlobal.tbLogMsg("Error! Could not add TB3Tab hooks correctly.");
	 }
	}
};
//Watches tab switches.
var ThunderBrowseMon = {
  onTabTitleChanged: function() { }, 
  onTabSwitched: function (aTab, aOldTab) 
  {
   TBrowserCore.toggleLaunch(true);	
   TBrowseNavBar.tabSwitch();
  }
};
