/*
NAME: ThunderBrowse Settings
AUTH: GameSpotting! Networks
DESC: In charge of saving, applying and loading user settings
*/

//This file is in need of more comments.
function $(object)
{
  return document.getElementById(object);
}

var ThunderBrowseSettings = {

  prefs: Components.classes["@mozilla.org/preferences-service;1"]
                         .getService(Components.interfaces.nsIPrefService).getBranch("extensions.tbrowse."),
  hprefs: Components.classes["@mozilla.org/preferences-service;1"]
                           .getService(Components.interfaces.nsIPrefService),
  lastKnownWindow: Components.classes["@mozilla.org/appshell/window-mediator;1"]
           .getService(Components.interfaces.nsIWindowMediator),
  windowType: null,
  changedTabSystem: false,
  changedPlugins: false,
  postboxExpress: false,
  canHaveTabs: false,
  isThunder: false,
  
  checkWindow: function()
  {
   var spicebirdId = "{ee53ece0-255c-4cc6-8a7e-81a8b6e5ba2c}";
   var thunderbirdId = "{3550f703-e582-4d05-9a08-453d09bdfdc6}";
   var postboxId = "postbox@postbox-inc.com";
   var expressBoxId = "express@postbox-inc.com";
   var appId = Components.classes["@mozilla.org/xre/app-info;1"].getService(Components.interfaces.nsIXULAppInfo).ID;
   if(appId == spicebirdId)
		this.windowType = "collab:main";
   else
		this.windowType = "mail:3pane";
   
   switch(appId)
   {
		case thunderbirdId:
		  this.canHaveTabs = (this.underTB3 == false);
      this.isThunder = true;
		break;
		case expressBoxId:
		  this.canHaveTabs = false;
		break;
		case postboxId:
		  this.canHaveTabs = false/*(this.checkAppVersion("2.0") == true)*/;
		break;
		case spicebirdId:
		  this.canHaveTabs = (this.checkAppVersion("0.8") == true);
		break;
   }

   return this.windowType;  
  },
  checkAppVersion: function(version2Check)
  {
      var versionChecker = Components.classes["@mozilla.org/xpcom/version-comparator;1"]
			.getService(Components.interfaces.nsIVersionComparator);
      var curAppVer = Components.classes["@mozilla.org/xre/app-info;1"]
                       .getService(Components.interfaces.nsIXULAppInfo).version;
      //running version number or later
      return (versionChecker.compare(curAppVer, version2Check) >= 0); 
  },
  get underTB3()
  {
     return (this.checkAppVersion("1.5") == true && this.checkAppVersion("3.0a1") != true);
  },
  checkTabDisplay: function()
  {
	if(this.canHaveTabs == false)
   {
      $("tbTabstab").setAttribute("hidden", true);
      $("tabSettingsPanel").setAttribute("collapsed", true);
      $("tabsSystem").selectedItem = 0;
      this.prefs.setIntPref("tabtype", 0);
      this.prefs.setBoolPref("contentTabs", false);
      this.prefs.setBoolPref("sessionHistory", false);
      this.prefs.setBoolPref("enableSessionRestore", false);     
   }
  },
  //Thunderbird automatically hides the help button. Show it.
  setHelpButton: function()
  {
     var helpbutton = document.getAnonymousElementByAttribute($("tbrowsesettings-win"), "dlgtype", "help");
     helpbutton.setAttribute("hidden",false);
     helpbutton.addEventListener("command", ThunderBrowseSettings.openHelp, false);   
  },
  openHelp: function()
  {
   var tbHelpUrl="http://thunderbrowse.com/help/";
   ThunderBrowseSettings.checkWindow();
   var gettbrowserwindow = ThunderBrowseSettings.lastKnownWindow.getMostRecentWindow(ThunderBrowseSettings.windowType);
   gettbrowserwindow.openDialog("chrome://tbrowse/content/tbwin.xul","_blank",
           "scrollbars,resizable,status,chrome,dialog=no",tbHelpUrl);
  },
  warnAboutTB3Tabs: function()
  {
    	var tabtype = this.prefs.getIntPref("tabtype");
	var affecterIds = ["tb3tabwarn1","tb3tabwarn2","tb3tabwarn3"];
	for(var i=0; i < affecterIds.length; i++)
	{
	  var theItem = document.getElementById(affecterIds[i]);
	  if(theItem && $("tabsSystem"))
	     theItem.hidden = ($("tabsSystem").selectedItem.value == 0);
	}
  },
  displayRestartPrompt: function()
  {
	var restarturlbar = $("tburlstrings2").getString('restartString');
	alert(restarturlbar);
  },
  clearHistory: function()
  {
  	this.checkWindow();
	var gettbrowserwindow = this.lastKnownWindow.getMostRecentWindow(this.windowType);
	if(gettbrowserwindow)
	{
		var tbwin = gettbrowserwindow.document;
		tbwin.getElementById("urlbar-bck").setAttribute("disabled","true");
		tbwin.getElementById("urlbar-fwd").setAttribute("disabled","true");
		ThunderBrowseSettings.prefs.setCharPref("dropdown","");
		ThunderBrowseSettings.prefs.setCharPref("gourlback","");
		ThunderBrowseSettings.prefs.setCharPref("gourlfwd","");
		//clear all browsing history
		var browserholder = tbwin.getElementById("thunderbrowse-deck");
		var allbrowsers = browserholder.getElementsByTagName("browser");
		for(var i = 0; i < allbrowsers.length; i++)
		{
			allbrowsers[i].setAttribute("history-forward","");
			allbrowsers[i].setAttribute("history-back","");
		}
		var mainBrowser = tbwin.getElementById("messagepane");
		mainBrowser.setAttribute("history-forward","");
		mainBrowser.setAttribute("history-back","");
		
	}
   },
   loadSettings: function()
   {
     this.checkWindow();
     	$("tbenablejs").setAttribute("checked",this.prefs.getBoolPref("dojavascript"));
	$("tbswitchtabs").setAttribute("checked",this.prefs.getBoolPref("tabswitch"));
	$("tbenablelabels").setAttribute("checked",this.prefs.getBoolPref("showlabels"));
      $("tbchangetitle").setAttribute("checked",this.prefs.getBoolPref("changetitle"));
	$("tbaskthem").setAttribute("checked",this.prefs.getBoolPref("askthem"));
	$("tbhidebar").setAttribute("checked",this.prefs.getBoolPref("removesub"));
	$("autocomplete").setAttribute("checked",this.prefs.getBoolPref("autocomplete"));
	$("autocompletefill").setAttribute("checked",this.prefs.getBoolPref("ACfillBar"));
	$("tbwhatsnew").setAttribute("checked", this.prefs.getBoolPref("shownew"));
      $("click2select").setAttribute("checked",this.prefs.getBoolPref("click2select"));
	$("tbwarnjs").setAttribute("checked",this.prefs.getBoolPref("warnjavascript"));
	$("tbmetaredir").setAttribute("checked",this.prefs.getBoolPref("allowRedir"));
	$("hidebookmarks").setAttribute("checked",this.prefs.getBoolPref("hidebookmarks"));
	$("tbdisable").setAttribute("checked",this.prefs.getBoolPref("loadother"));
	$("tbplacebottom").setAttribute("checked",this.prefs.getBoolPref("placeBottom"));
	$("tbextnal").setAttribute("checked",this.prefs.getBoolPref("linkWind"));
	$("tbenableimages").setAttribute("checked",this.prefs.getBoolPref("respectImg"));
	$("tbenableplugins").setAttribute("checked",(this.pluginPref == true));
	$("tabscloselikeFX").setAttribute("checked",this.prefs.getBoolPref("tabsCloseFX"));
	$("tbcontenttabs").setAttribute("checked", this.prefs.getBoolPref("contentTabs"));
	$("tbsessionrestore").setAttribute("checked", this.prefs.getBoolPref("enableSessionRestore"));
	$("tbsessionhistory").setAttribute("checked", this.prefs.getBoolPref("sessionHistory"));
	$("tbenablecookies").setAttribute("checked",
                             (!(this.hprefs.getBoolPref("network.cookie.disableCookieForMailNews"))));
      document.getElementById("tabsSystem").selectedItem = $("tabsSystem").childNodes[this.prefs.getIntPref("tabtype")]                            
	if(this.prefs.getCharPref("customlauncher"))
	{
		var thepath = this.prefs.getCharPref("customlauncher");
		$("pathtocustom").setAttribute("value",thepath);
	}
	if(this.prefs.getBoolPref("lefttab") == true)
	{
		$("newtab2").setAttribute("selected",true);
		$("currentab").setAttribute("selected",false);
	}
	else
	{
		$("currentab").setAttribute("selected",true);
		$("newtab2").setAttribute("selected",false);
	}
	if(this.prefs.getBoolPref("middletabs") == true)
	{
		$("newtab").setAttribute("selected",true);
		$("newbrowser").setAttribute("selected",false);
	}
	else
	{
		$("newbrowser").setAttribute("selected",true);
		$("newtab").setAttribute("selected",false);
	}
        if($("tbwinkey") && this.prefs.getCharPref("winkey") != "")
		$("tbwinkey").setAttribute("value",this.prefs.getCharPref("winkey"));
	if($("tbtabkey") && this.prefs.getCharPref("tabkey") != "")
		$("tbtabkey").setAttribute("value",this.prefs.getCharPref("tabkey"));
	document.getElementById("ctrlclk").selectedItem = $("ctrlclk").childNodes[this.prefs.getIntPref("ctrlclk")];
	if(this.prefs.getBoolPref("historyAccl") == true)
          document.getElementById("bckfwdmod").selectedItem = $("bckfwdmod").childNodes[1];
      else
	    document.getElementById("bckfwdmod").selectedItem = $("bckfwdmod").childNodes[0];  
	this.setHelpButton();
      this.checkTabDisplay();      
   },
   saveSettings: function()
   {
      this.prefs.setBoolPref("dojavascript", $("tbenablejs").checked);
      this.prefs.setBoolPref("warnjavascript", $("tbwarnjs").checked);
      this.prefs.setBoolPref("allowRedir", $("tbmetaredir").checked);
      this.prefs.setBoolPref("showlabels", $("tbenablelabels").checked);
      this.prefs.setBoolPref("changetitle", $("tbchangetitle").checked);
      this.prefs.setBoolPref("askthem", $("tbaskthem").checked);
      this.prefs.setBoolPref("tabswitch", $("tbswitchtabs").checked);
      this.prefs.setBoolPref("click2select", $("click2select").checked);
      this.prefs.setBoolPref("hidebookmarks", $("hidebookmarks").checked);
      this.prefs.setBoolPref("removesub", $("tbhidebar").checked);
      this.prefs.setBoolPref("autocomplete", $("autocomplete").checked);
      this.prefs.setBoolPref("ACfillBar", $("autocompletefill").checked);
      this.prefs.setBoolPref("placeBottom", $("tbplacebottom").checked);
      this.prefs.setBoolPref("linkWind", $("tbextnal").checked);
      this.prefs.setBoolPref("respectImg", $("tbenableimages").checked);
      this.prefs.setBoolPref("shownew", $("tbwhatsnew").checked);
      this.prefs.setBoolPref("loadother", $("tbdisable").checked);
      this.prefs.setBoolPref("tabsCloseFX", $("tabscloselikeFX").checked);
      this.prefs.setBoolPref("contentTabs", $("tbcontenttabs").checked);
      this.prefs.setBoolPref("enableSessionRestore", $("tbsessionrestore").checked);
      this.prefs.setBoolPref("sessionHistory", $("tbsessionhistory").checked);
		
		if($("tbenableplugins").checked != this.pluginPref)
		{
				this.changedPlugins = true;
				this.hprefs.setBoolPref("plugin.disable", !($("tbenableplugins").checked));
        
				this.pluginPref = $("tbenableplugins").checked;
		}
      //Setting TB3 tabs settings
		if(this.canHaveTabs == true)
      {
	      if(this.prefs.getIntPref("tabtype") != $("tabsSystem").selectedItem.value)
        	   this.changedTabSystem = true;
	      this.prefs.setIntPref("tabtype", $("tabsSystem").selectedItem.value);
      }
      //this is because ThunderBrowse doesn't manage cookies
      this.hprefs.setBoolPref("network.cookie.disableCookieForMailNews",(!($("tbenablecookies").checked)));
      //control click radio group pref save
      if($("ctrlclk").selectedItem.value != null)
        this.prefs.setIntPref("ctrlclk", $("ctrlclk").selectedItem.value);
      else
        this.prefs.setIntPref("ctrlclk",0);
      //history key radio group pref save
      if($("bckfwdmod").selectedItem.value == "true")
        this.prefs.setBoolPref("historyAccl", true);
      else
        this.prefs.setBoolPref("historyAccl", false);
      //set customkey
      if($("tbwinkey") && $("tbwinkey").value != "")
        this.prefs.setCharPref("winkey", $("tbwinkey").value);
      if($("tbtabkey") && $("tbtabkey").value != "")
        this.prefs.setCharPref("tabkey", $("tbtabkey").value);
      //if custom browser is defined then remove the current http handler
      if($("pathtocustom") && $("pathtocustom").value != "")
      {
      	this.prefs.setCharPref("customlauncher", $("pathtocustom").value);
      	this.hprefs.setCharPref("network.protocol-handler.app.http","");
      }
      if($("pathtocustom").value == "")
         this.prefs.setCharPref("customlauncher","");
      var helpbutton = document.getAnonymousElementByAttribute($("tbrowsesettings-win"), "dlgtype", "help");
      helpbutton.removeEventListener("command", ThunderBrowseSettings.openHelp, false);
      this.applySettings();   
   },
   applySettings: function()
   {
    try
	{
		var tbstrings = $("tburlstrings2");
		var backurlbar = tbstrings.getString('backurlString');
		var refreshbar = tbstrings.getString('refreshurlString');
		var forwardbar = tbstrings.getString('forwardurlString');
		var gobar = tbstrings.getString('gourlString');
		
		//get thunderbird
		this.checkWindow();
		var gettbrowserwindow = this.lastKnownWindow.getMostRecentWindow(this.windowType);
		if(gettbrowserwindow)
		{
			var tbwin = gettbrowserwindow.document;
			if(ThunderBrowseSettings.prefs.getBoolPref("showlabels") == false)
			{
				tbwin.getElementById("urlbar-bck").setAttribute("label","");
				tbwin.getElementById("urlbar-fwd").setAttribute("label","");
				tbwin.getElementById("urlbar-ref").setAttribute("label","");
				tbwin.getElementById("urlbar-go").setAttribute("label","");
			}
			else
			{
				tbwin.getElementById("urlbar-bck").setAttribute("label"," "+backurlbar);
				tbwin.getElementById("urlbar-fwd").setAttribute("label"," "+forwardbar);
				tbwin.getElementById("urlbar-ref").setAttribute("label"," "+refreshbar);
				tbwin.getElementById("urlbar-go").setAttribute("label"," "+gobar);
			}
			if($("tbwinkey") && ThunderBrowseSettings.prefs.getCharPref("winkey") != "" && 
                     ThunderBrowseSettings.prefs.getCharPref("winkey") != "W")
				tbwin.getElementById("key_tbrowsewind").setAttribute("key",
				                      ThunderBrowseSettings.prefs.getCharPref("winkey"));
			else
				tbwin.getElementById("key_tbrowsewind").setAttribute("key","W");
                        if($("tbtabkey") && ThunderBrowseSettings.prefs.getCharPref("tabkey") != "" && 
                           ThunderBrowseSettings.prefs.getCharPref("tabkey") != "B")
				tbwin.getElementById("key_tbrowsenewtab").setAttribute("key",
	   			                      ThunderBrowseSettings.prefs.getCharPref("tabkey"));
			else
				tbwin.getElementById("key_tbrowsenewtab").setAttribute("key","B");

			tbwin.getElementById("urlfield").setAttribute("clickSelectsAll",
					ThunderBrowseSettings.prefs.getBoolPref("click2select"));
			tbwin.getElementById("urlfield").setAttribute("showpopup",
					ThunderBrowseSettings.prefs.getBoolPref("autocomplete"));
			tbwin.getElementById("tb-Bookmarks").setAttribute("hidden",
					ThunderBrowseSettings.prefs.getBoolPref("hidebookmarks"));
					
			if(ThunderBrowseSettings.prefs.getBoolPref("historyAccl") == true)
			{
			      tbwin.getElementById('key_tbrowseback').setAttribute("modifiers","alt");
			      tbwin.getElementById('key_tbrowseforward').setAttribute("modifiers","alt");			 
			}
			else
			{
			      tbwin.getElementById('key_tbrowseback').setAttribute("modifiers","control accel");
			      tbwin.getElementById('key_tbrowseforward').setAttribute("modifiers","control accel");			
			}      
			var tb_statusBar = tbwin.getElementById("statusbar-thunderbrowse-image");
			if(ThunderBrowseSettings.prefs.getBoolPref("loadother") == false)
			 tb_statusBar.setAttribute("src","chrome://tbrowse/content/images/yes-tb.png");
			else
		    	 tb_statusBar.setAttribute("src","chrome://tbrowse/content/images/no-tb.png");
        if(this.changedTabSystem == true || this.changedPlugins == true)
           this.displayRestartPrompt();
		}
		else
                this.displayRestartPrompt();
	}
	catch(e)
	{
	 this.displayRestartPrompt();
	}   
   },
   saveRBStatus: function(event)
   {
     if(event.target == $("newtab"))
      this.prefs.setBoolPref("middletabs",true);
     if(event.target == $("newbrowser"))
      this.prefs.setBoolPref("middletabs",false);   
     if(event.target == $("currentab"))
      this.prefs.setBoolPref("lefttab",false);
     if(event.target == $("newtab2"))
      this.prefs.setBoolPref("lefttab",true);
  },
  keyBoxFocus: function(id)
  {
    	$(id).value="";
	var tbstrings = $("tburlstrings2");
	var pressakey = tbstrings.getString('pressurlString');
	$(id).value=pressakey;
	$(id).setAttribute("style","color:rgb(128, 128, 128);");  
  },
  checkKeys: function(event, id)
  {
  	if(event.shiftKey != true && event.ctrlKey != true && event.altKey != true && event.metaKey != true)
	{
		$(id).setAttribute("style","color:rgb(0, 0, 0);");
		$(id).value="";	
		var codeword = String.fromCharCode(event.charCode);
		$(id).setAttribute("value",codeword);
	}
  },
  aboutSurfer: function(event)
  {
   	if(event.target.nodeName == "A" || event.target.parentNode.nodeName == "A")
	{
	  event.preventDefault();
	  var linkfromevent;
	  if(event.target.parentNode.nodeName == "A")
	   linkfromevent = event.target.parentNode.href;
	  else
	   linkfromevent = event.target.href;
        window.openDialog("chrome://tbrowse/content/tbwin.xul",
                  "_blank","scrollbars,resizable,status,chrome,dialog=no",linkfromevent);
	}  
  },
  get pluginPref()
  {
    if(this.isThunder && this.checkAppVersion("4.0"))
      return this.hprefs.getBoolPref("mailnews.message_display.allow_plugins");
    else
      return this.hprefs.getBoolPref("mailnews.message_display.allow.plugins");
  },
  
  set pluginPref(newVal)
  {
    if(this.isThunder && this.checkAppVersion("4.0"))
      this.hprefs.setBoolPref("mailnews.message_display.allow_plugins", newVal);
    else
      this.hprefs.setBoolPref("mailnews.message_display.allow.plugins", newVal);
  }
};

